Index: /palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4399)
+++ /palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 4400)
@@ -1546,75 +3061,115 @@
                     ENDDO
                  ENDIF
-                 
-              CASE ( 'rsd' )
+
+              CASE ( 'rsd' ) ! shortwave in
                  IF ( radiation )  THEN
-                    DO  m = 1, vmea(l)%ns
-                       k = MERGE( 0, vmea(l)%k(m), radiation_scheme /= 'rrtmg' ) 
-                       j = vmea(l)%j(m)
-                       i = vmea(l)%i(m)
-                    
-                       vmea(l)%measured_vars(m,n) = rad_sw_in(k,j,i)
-                    ENDDO
+                    IF ( radiation_scheme /= 'rrtmg' )  THEN
+                       DO  m = 1, vmea(l)%ns
+                          k = 0
+                          j = vmea(l)%j(m)
+                          i = vmea(l)%i(m)
+                          vmea(l)%measured_vars(m,n) = rad_sw_in(k,j,i)
+                       ENDDO
+                    ELSE
+                       DO  m = 1, vmea(l)%ns
+                          k = vmea(l)%k(m)
+                          j = vmea(l)%j(m)
+                          i = vmea(l)%i(m)
+                          vmea(l)%measured_vars(m,n) = rad_sw_in(k,j,i)
+                       ENDDO
+                    ENDIF
                  ENDIF
-                 
-              CASE ( 'rsu' )
+
+              CASE ( 'rsu' ) ! shortwave out
                  IF ( radiation )  THEN
-                    DO  m = 1, vmea(l)%ns
-                       k = MERGE( 0, vmea(l)%k(m), radiation_scheme /= 'rrtmg' ) 
-                       j = vmea(l)%j(m)
-                       i = vmea(l)%i(m)
-                    
-                       vmea(l)%measured_vars(m,n) = rad_sw_out(k,j,i)
-                    ENDDO
+                    IF ( radiation_scheme /= 'rrtmg' )  THEN
+                       DO  m = 1, vmea(l)%ns
+                          k = 0
+                          j = vmea(l)%j(m)
+                          i = vmea(l)%i(m)
+                          vmea(l)%measured_vars(m,n) = rad_sw_out(k,j,i)
+                       ENDDO
+                    ELSE
+                       DO  m = 1, vmea(l)%ns
+                          k = vmea(l)%k(m)
+                          j = vmea(l)%j(m)
+                          i = vmea(l)%i(m)
+                          vmea(l)%measured_vars(m,n) = rad_sw_out(k,j,i)
+                       ENDDO
+                    ENDIF
                  ENDIF
-                 
-              CASE ( 'rlu' )
+
+              CASE ( 'rlu' ) ! longwave out
                  IF ( radiation )  THEN
-                    DO  m = 1, vmea(l)%ns
-                       k = MERGE( 0, vmea(l)%k(m), radiation_scheme /= 'rrtmg' ) 
-                       j = vmea(l)%j(m)
-                       i = vmea(l)%i(m)
-                    
-                       vmea(l)%measured_vars(m,n) = rad_lw_out(k,j,i)
-                    ENDDO
+                    IF ( radiation_scheme /= 'rrtmg' )  THEN
+                       DO  m = 1, vmea(l)%ns
+                          k = 0
+                          j = vmea(l)%j(m)
+                          i = vmea(l)%i(m)
+                          vmea(l)%measured_vars(m,n) = rad_lw_out(k,j,i)
+                       ENDDO
+                    ELSE
+                       DO  m = 1, vmea(l)%ns
+                          k = vmea(l)%k(m)
+                          j = vmea(l)%j(m)
+                          i = vmea(l)%i(m)
+                          vmea(l)%measured_vars(m,n) = rad_lw_out(k,j,i)
+                       ENDDO
+                    ENDIF
                  ENDIF
-                 
-              CASE ( 'rld' )
+
+              CASE ( 'rld' ) ! longwave in
                  IF ( radiation )  THEN
-                    DO  m = 1, vmea(l)%ns
-                       k = MERGE( 0, vmea(l)%k(m), radiation_scheme /= 'rrtmg' ) 
-                       j = vmea(l)%j(m)
-                       i = vmea(l)%i(m)
-                    
-                       vmea(l)%measured_vars(m,n) = rad_lw_in(k,j,i)
-                    ENDDO
+                    IF ( radiation_scheme /= 'rrtmg' )  THEN
+                       DO  m = 1, vmea(l)%ns
+                          k = 0
+!
+!--                       Surface data is only available on inner subdomains,
+!--                       not on ghost points. Hence, limit the indices.
+                          j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                          j = MERGE( j           , nyn, j            < nyn )
+                          i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                          i = MERGE( i           , nxr, i            < nxr )
+
+                          vmea(l)%measured_vars(m,n) = rad_lw_in(k,j,i)
+                       ENDDO
+                    ELSE
+                       DO  m = 1, vmea(l)%ns
+                          k = vmea(l)%k(m)
+                          j = vmea(l)%j(m)
+                          i = vmea(l)%i(m)
+                          vmea(l)%measured_vars(m,n) = rad_lw_in(k,j,i)
+                       ENDDO
+                    ENDIF
                  ENDIF
-                 
-              CASE ( 'rsddif' )
+
+              CASE ( 'rsddif' ) ! shortwave in, diffuse part
                  IF ( radiation )  THEN
                     DO  m = 1, vmea(l)%ns
                        j = vmea(l)%j(m)
                        i = vmea(l)%i(m)
-                    
+
                        vmea(l)%measured_vars(m,n) = rad_sw_in_diff(j,i)
                     ENDDO
                  ENDIF
-                 
-              CASE ( 't_soil' )
+
+              CASE ( 't_soil' ) ! soil and wall temperature
                  DO  m = 1, vmea(l)%ns_soil
-                    i = vmea(l)%i_soil(m)
-                    j = vmea(l)%j_soil(m)
+                    j = MERGE( vmea(l)%j_soil(m), nys, vmea(l)%j_soil(m) > nys )
+                    j = MERGE( j                , nyn, j                 < nyn )
+                    i = MERGE( vmea(l)%i_soil(m), nxl, vmea(l)%i_soil(m) > nxl )
+                    i = MERGE( i                , nxr, i                 < nxr )
                     k = vmea(l)%k_soil(m)
-                    
+
                     match_lsm = surf_lsm_h%start_index(j,i) <=                 &
                                 surf_lsm_h%end_index(j,i)
                     match_usm = surf_usm_h%start_index(j,i) <=                 &
                                 surf_usm_h%end_index(j,i)
-                                
+
                     IF ( match_lsm )  THEN
                        mm = surf_lsm_h%start_index(j,i)
                        vmea(l)%measured_vars_soil(m,n) = t_soil_h%var_2d(k,mm)
                     ENDIF
-                    
+
                     IF ( match_usm )  THEN
                        mm = surf_usm_h%start_index(j,i)
@@ -1622,19 +3177,84 @@
                     ENDIF
                  ENDDO
-                 
-              CASE ( 'm_soil' )
+
+              CASE ( 'm_soil' ) ! soil moisture
                  DO  m = 1, vmea(l)%ns_soil
-                    i = vmea(l)%i_soil(m)
-                    j = vmea(l)%j_soil(m)
+                    j = MERGE( vmea(l)%j_soil(m), nys, vmea(l)%j_soil(m) > nys )
+                    j = MERGE( j                , nyn, j                 < nyn )
+                    i = MERGE( vmea(l)%i_soil(m), nxl, vmea(l)%i_soil(m) > nxl )
+                    i = MERGE( i                , nxr, i                 < nxr )
                     k = vmea(l)%k_soil(m)
-                    
+
                     match_lsm = surf_lsm_h%start_index(j,i) <=                 &
                                 surf_lsm_h%end_index(j,i)
-                                
+
                     IF ( match_lsm )  THEN
                        mm = surf_lsm_h%start_index(j,i)
                        vmea(l)%measured_vars_soil(m,n) = m_soil_h%var_2d(k,mm)
                     ENDIF
-                    
+
+                 ENDDO
+
+              CASE ( 'ts' ) ! surface temperature
+                 DO  m = 1, vmea(l)%ns
+!
+!--                 Surface data is only available on inner subdomains, not
+!--                 on ghost points. Hence, limit the indices.
+                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                    j = MERGE( j           , nyn, j            < nyn )
+                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                    i = MERGE( i           , nxr, i            < nxr )
+
+                    DO  mm = surf_def_h(0)%start_index(j,i),                   &
+                             surf_def_h(0)%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_def_h(0)%pt_surface(mm)
+                    ENDDO
+                    DO  mm = surf_lsm_h%start_index(j,i),                      &
+                             surf_lsm_h%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_lsm_h%pt_surface(mm)
+                    ENDDO
+                    DO  mm = surf_usm_h%start_index(j,i),                      &
+                             surf_usm_h%end_index(j,i)
+                       vmea(l)%measured_vars(m,n) = surf_usm_h%pt_surface(mm)
+                    ENDDO
+                 ENDDO
+
+              CASE ( 'lwp' ) ! liquid water path
+                 IF ( ASSOCIATED( ql ) )  THEN
+                    DO  m = 1, vmea(l)%ns
+                       j = vmea(l)%j(m)
+                       i = vmea(l)%i(m)
+
+                       vmea(l)%measured_vars(m,n) = SUM( ql(nzb:nzt,j,i)       &
+                                                       * dzw(1:nzt+1) )        &
+                                                  * rho_surface
+                    ENDDO
+                 ENDIF
+
+              CASE ( 'ps' ) ! surface pressure
+                 vmea(l)%measured_vars(:,n) = surface_pressure
+
+              CASE ( 'pswrtg' ) ! platform speed above ground
+                 vmea(l)%measured_vars(:,n) = 0.0_wp
+
+              CASE ( 'pswrta' ) ! platform speed in air
+                 vmea(l)%measured_vars(:,n) = 0.0_wp
+
+              CASE ( 't_lw' ) ! water temperature
+                 DO  m = 1, vmea(l)%ns
+!
+!--                 Surface data is only available on inner subdomains, not
+!--                 on ghost points. Hence, limit the indices.
+                    j = MERGE( vmea(l)%j(m), nys, vmea(l)%j(m) > nys )
+                    j = MERGE( j           , nyn, j            < nyn )
+                    i = MERGE( vmea(l)%i(m), nxl, vmea(l)%i(m) > nxl )
+                    i = MERGE( i           , nxr, i            < nxr )
+
+                    DO  mm = surf_lsm_h%start_index(j,i),                      &
+                             surf_lsm_h%end_index(j,i)
+                       IF ( surf_lsm_h%water_surface(m) )                      &
+                          vmea(l)%measured_vars(m,n) = t_soil_h%var_2d(nzt,m)
+                    ENDDO
+
                  ENDDO
 !
@@ -1650,7 +3270,7 @@
 
      ENDDO
-          
+
   END SUBROUTINE vm_sampling
- 
+
 
  END MODULE virtual_measurement_mod
